function plotcos2d(a,n)
% plots the numerical approximate solution

gr=linspace(0,pi,50);
[x,y]=ndgrid(gr,gr);
[kx,ky]=ndgrid(0:n(1),0:n(2));
factor=4*ones(size(kx));
factor(kx==0)=factor(kx==0)/2;
factor(ky==0)=factor(ky==0)/2;

z=zeros(size(x));
for i=1:length(kx(:))
   z=z+a(i)*factor(i)*cos(kx(i)*x).*cos(ky(i)*y);
end

surf(x,y,z)
axis tight

end

