% This script does "manual" branch switching
% to get to a secondary branch
% It is manual in the sense that a lot of many tweaking
% and a bit of luck was needed

nmodes=20;

kx=1;
ky=2;

lambda=kx^2+ky^2;

a=zeros(nmodes+1);
a(kx+1,ky+1)=1;
a(ky+1,kx+1)=0;
n=size(a)-1;
a=a(:);

amplitude=0.01;
a=amplitude*a;

stepsize=0.05;
steps=210;

dlambda0=0;
da0=a/norm(a);

bifdone=0;
i=1;
maxnewton=15;
tol=1e-12;
while i<steps 
    display(['i=',int2str(i)])
    counter=1;
    del=tol+1;
    while counter<maxnewton && del>tol
         [F,DF,~,~,DFlambda]=FDF(a,lambda,n);
         Fext=[F;0];  
         Jext=[DF,DFlambda;da0',dlambda0']; %Newton-chord
         delta=-Jext\Fext;
         da=delta(1:end-1);
         dlambda=delta(end);
         a=a+da;
         lambda=lambda+dlambda;
         dx0=Jext\[zeros(length(a),1);1];
         dx0=dx0/norm(dx0);
         da0=dx0(1:end-1);
         dlambda0=dx0(end);
         del=sum(abs(delta));
    end
     if counter==maxnewton
         display(['Newton did not converge; del is ',num2str(del)])
     end
     plotcos2d(mid(a),n);
     drawnow
     [eigvec,eigval]=eigs(DF,1,'sm');
     eigenval=diag(eigval)';
     display(['small eigenvalues: ',num2str(eigenval)]);
     if i>10 && abs(eigenval)<0.02 && ~bifdone
         eigenvec=eigvec/norm(eigvec);
         da0=-eigenvec;
         dlambda0=0;
         bifstepsize=0.02;
         lambda=lambda+bifstepsize*dlambda0;
         a=a+bifstepsize*da0;         
         disp(['Bifurcation at lambda = ',num2str(lambda)])
         pause(1);         
         bifdone=1;
     else
         lambda=lambda+stepsize*dlambda0;
         a=a+stepsize*da0;         
     end
     display(['lambda is ',num2str(lambda)]);
     i=i+1;
     if abs(lambda-12)<stepsize
         b=a;
        save('data12/solbif2','b','lambda','n')
     end
     if abs(lambda-15)<stepsize
         b=a;
        save('data15/solbif2','b','lambda','n')
     end
end

