% this script tries Newton iterations from initial data
% near primary bifurcation points

lambda=15;
disp(['Performing a primary branch search for lambda = ',num2str(lambda)]);

% maximum value of the bifurcation modes k
total=[3,3];
nmodes=20;

n=[nmodes,nmodes];
a=zeros(n+1);

nsol=1;

% big loop that tries many things
for Q=1:3
    figure(Q)
    counttot=1;
    for counter1=1:4
        for counter2=1:min(3,counter1)
            a=zeros(n+1);
            a(counter1,counter2)=1;
            if Q==2
                if counter1==counter2
                    a=zeros(n+1);
                else
                    % try some symmetric combination
                    a=(a+a')/2;
                end
            elseif Q==3    
                    % try some antisymmetric combination
                    a=(a-a')/5;
            end
            aa=a(:);
            [b,res,iter,morse]=newtoniterate(aa,lambda,n);
          if iter<20
            % convergence  
            subplot(total(1),total(2),counttot)
            plotcos2d(b,n);
            title(int2str(morse));
            drawnow;    
            disp(['wavenumbers ',int2str(counter1-1),' ',int2str(counter2-1)]);
            if Q==1 || (Q==2 && counttot>3 && ~(counttot==8)) || (Q==3 && (counttot==4 || counttot>7) )
                % selected by hand which ones look good and different 
                % these data are saved
                disp('decided to save the data')
                save(['data15/sol',int2str(nsol)],'lambda','b','n');  
                nsol=nsol+1;
            end
            counttot=counttot+1;
          end
        end
    end
end



